Index: /branches/2017/dev_merge_2017/NEMOGCM/NEMO/OPA_SRC/LDF/ldfdyn.F90
===================================================================
--- /branches/2017/dev_merge_2017/NEMOGCM/NEMO/OPA_SRC/LDF/ldfdyn.F90	(revision 9018)
+++ /branches/2017/dev_merge_2017/NEMOGCM/NEMO/OPA_SRC/LDF/ldfdyn.F90	(revision 9019)
@@ -24,5 +24,4 @@
    USE lib_mpp         ! distribued memory computing library
    USE lbclnk          ! ocean lateral boundary conditions (or mpp link)
-   USE wrk_nemo        ! Memory Allocation
 
    IMPLICIT NONE
@@ -33,4 +32,5 @@
 
    !                                                !!* Namelist namdyn_ldf : lateral mixing on momentum *
+   LOGICAL , PUBLIC ::   ln_dynldf_NONE  !: No operator (i.e. no explicit diffusion)
    LOGICAL , PUBLIC ::   ln_dynldf_lap   !: laplacian operator
    LOGICAL , PUBLIC ::   ln_dynldf_blp   !: bilaplacian operator
@@ -96,8 +96,8 @@
       REAL(wp) ::   zah0              ! local scalar
       !
-      NAMELIST/namdyn_ldf/ ln_dynldf_lap, ln_dynldf_blp,                  &
-         &                 ln_dynldf_lev, ln_dynldf_hor, ln_dynldf_iso,   &
-         &                 nn_ahm_ijk_t , rn_ahm_0, rn_ahm_b, rn_bhm_0,   &
-         &                 rn_csmc      , rn_minfac, rn_maxfac
+      NAMELIST/namdyn_ldf/ ln_dynldf_NONE, ln_dynldf_lap, ln_dynldf_blp,   &   ! type of operator
+         &                 ln_dynldf_lev, ln_dynldf_hor, ln_dynldf_iso ,   &   ! acting direction of the operator
+         &                 nn_ahm_ijk_t , rn_ahm_0, rn_ahm_b, rn_bhm_0 ,   &   ! lateral eddy coefficient
+         &                 rn_csmc      , rn_minfac, rn_maxfac                 ! Smagorinsky settings
       !!----------------------------------------------------------------------
       !
@@ -118,4 +118,5 @@
          !
          WRITE(numout,*) '      type :'
+         WRITE(numout,*) '         no explicit diffusion                ln_dynldf_NONE= ', ln_dynldf_NONE
          WRITE(numout,*) '         laplacian operator                   ln_dynldf_lap = ', ln_dynldf_lap
          WRITE(numout,*) '         bilaplacian operator                 ln_dynldf_blp = ', ln_dynldf_blp
@@ -131,5 +132,5 @@
          WRITE(numout,*) '         background viscosity (iso case)      rn_ahm_b      = ', rn_ahm_b, ' m2/s'
          WRITE(numout,*) '         lateral bilaplacian eddy viscosity   rn_bhm_0      = ', rn_bhm_0, ' m4/s'
-         WRITE(numout,*) '      smagorinsky settings (nn_ahm_ijk_t  = 32) :'
+         WRITE(numout,*) '      Smagorinsky settings (nn_ahm_ijk_t  = 32) :'
          WRITE(numout,*) '         Smagorinsky coefficient              rn_csmc       = ', rn_csmc
          WRITE(numout,*) '         factor multiplier for theorectical lower limit for '
@@ -140,5 +141,5 @@
 
       !                                ! Parameter control
-      IF( .NOT.ln_dynldf_lap .AND. .NOT.ln_dynldf_blp ) THEN
+      IF( ln_dynldf_NONE ) THEN
          IF(lwp) WRITE(numout,*) '   No viscous operator selected. ahmt and ahmf are not allocated'
          l_ldfdyn_time = .FALSE.
@@ -284,5 +285,5 @@
       !!----------------------------------------------------------------------
       !
-      IF( nn_timing == 1 )  CALL timing_start('ldf_dyn')
+      IF( ln_timing )   CALL timing_start('ldf_dyn')
       !
       SELECT CASE(  nn_ahm_ijk_t  )       !== Eddy vicosity coefficients ==!
@@ -411,5 +412,5 @@
       CALL iom_put( "ahmf_3d", ahmf(:,:,:) )   ! 3D      v-eddy diffusivity coeff.
       !
-      IF( nn_timing == 1 )  CALL timing_stop('ldf_dyn')
+      IF( ln_timing )   CALL timing_stop('ldf_dyn')
       !
    END SUBROUTINE ldf_dyn
Index: /branches/2017/dev_merge_2017/NEMOGCM/NEMO/OPA_SRC/LDF/ldfslp.F90
===================================================================
--- /branches/2017/dev_merge_2017/NEMOGCM/NEMO/OPA_SRC/LDF/ldfslp.F90	(revision 9018)
+++ /branches/2017/dev_merge_2017/NEMOGCM/NEMO/OPA_SRC/LDF/ldfslp.F90	(revision 9019)
@@ -32,5 +32,4 @@
    USE lib_mpp        ! distribued memory computing library
    USE lib_fortran    ! Fortran utilities (allows no signed zero when 'key_nosignedzero' defined)
-   USE wrk_nemo       ! work arrays
    USE timing         ! Timing
 
@@ -118,15 +117,11 @@
       REAL(wp) ::   zck, zfk,      zbw             !   -      -
       REAL(wp) ::   zdepu, zdepv                   !   -      -
-      REAL(wp), POINTER, DIMENSION(:,:  ) ::  zslpml_hmlpu, zslpml_hmlpv
-      REAL(wp), POINTER, DIMENSION(:,:,:) ::  zwz, zww
-      REAL(wp), POINTER, DIMENSION(:,:,:) ::  zdzr
-      REAL(wp), POINTER, DIMENSION(:,:,:) ::  zgru, zgrv
-      !!----------------------------------------------------------------------
-      !
-      IF( nn_timing == 1 )  CALL timing_start('ldf_slp')
-      !
-      CALL wrk_alloc( jpi,jpj,jpk, zwz, zww, zdzr, zgru, zgrv )
-      CALL wrk_alloc( jpi,jpj, zslpml_hmlpu, zslpml_hmlpv )
-
+      REAL(wp), DIMENSION(jpi,jpj)     ::  zslpml_hmlpu, zslpml_hmlpv
+      REAL(wp), DIMENSION(jpi,jpj,jpk) ::  zgru, zwz, zdzr
+      REAL(wp), DIMENSION(jpi,jpj,jpk) ::  zgrv, zww
+      !!----------------------------------------------------------------------
+      !
+      IF( ln_timing )   CALL timing_start('ldf_slp')
+      !
       zeps   =  1.e-20_wp        !==   Local constant initialization   ==!
       z1_16  =  1.0_wp / 16._wp
@@ -157,6 +152,6 @@
          DO jj = 1, jpjm1
             DO ji = 1, jpim1
-               IF ( miku(ji,jj) > 1 ) zgru(ji,jj,miku(ji,jj)) = grui(ji,jj) 
-               IF ( mikv(ji,jj) > 1 ) zgrv(ji,jj,mikv(ji,jj)) = grvi(ji,jj)
+               IF( miku(ji,jj) > 1 )   zgru(ji,jj,miku(ji,jj)) = grui(ji,jj) 
+               IF( mikv(ji,jj) > 1 )   zgrv(ji,jj,mikv(ji,jj)) = grvi(ji,jj)
             END DO
          END DO
@@ -375,8 +370,5 @@
       ENDIF
       !
-      CALL wrk_dealloc( jpi,jpj,jpk, zwz, zww, zdzr, zgru, zgrv )
-      CALL wrk_dealloc( jpi,jpj, zslpml_hmlpu, zslpml_hmlpv )
-      !
-      IF( nn_timing == 1 )  CALL timing_stop('ldf_slp')
+      IF( ln_timing )   CALL timing_stop('ldf_slp')
       !
    END SUBROUTINE ldf_slp
@@ -409,16 +401,12 @@
       REAL(wp) ::   zdzrho_raw
       REAL(wp) ::   zbeta0, ze3_e1, ze3_e2
-      REAL(wp), POINTER, DIMENSION(:,:)     ::   z1_mlbw
-      REAL(wp), POINTER, DIMENSION(:,:,:)   ::   zalbet
-      REAL(wp), POINTER, DIMENSION(:,:,:,:) ::   zdxrho , zdyrho, zdzrho     ! Horizontal and vertical density gradients
-      REAL(wp), POINTER, DIMENSION(:,:,:,:) ::   zti_mlb, ztj_mlb            ! for Griffies operator only
-      !!----------------------------------------------------------------------
-      !
-      IF( nn_timing == 1 )  CALL timing_start('ldf_slp_triad')
-      !
-      CALL wrk_alloc( jpi,jpj, z1_mlbw )
-      CALL wrk_alloc( jpi,jpj,jpk, zalbet )
-      CALL wrk_alloc( jpi,jpj,jpk,2, zdxrho , zdyrho, zdzrho,              klstart = 0  )
-      CALL wrk_alloc( jpi,jpj,  2,2, zti_mlb, ztj_mlb,        kkstart = 0, klstart = 0  )
+      REAL(wp), DIMENSION(jpi,jpj)     ::   z1_mlbw
+      REAL(wp), DIMENSION(jpi,jpj,jpk) ::   zalbet
+      REAL(wp), DIMENSION(jpi,jpj,jpk,0:1) ::   zdxrho , zdyrho, zdzrho     ! Horizontal and vertical density gradients
+      REAL(wp), DIMENSION(jpi,jpj,0:1,0:1) ::   zti_mlb, ztj_mlb            ! for Griffies operator only
+      !!----------------------------------------------------------------------
+      !
+      IF( ln_timing )   CALL timing_start('ldf_slp_triad')
+      !
       !
       !--------------------------------!
@@ -624,10 +612,5 @@
       CALL lbc_lnk( wslp2, 'W', 1. )      ! lateral boundary confition on wslp2 only   ==>>> gm : necessary ? to be checked
       !
-      CALL wrk_dealloc( jpi,jpj, z1_mlbw )
-      CALL wrk_dealloc( jpi,jpj,jpk, zalbet )
-      CALL wrk_dealloc( jpi,jpj,jpk,2, zdxrho , zdyrho, zdzrho,              klstart = 0  )
-      CALL wrk_dealloc( jpi,jpj,  2,2, zti_mlb, ztj_mlb,        kkstart = 0, klstart = 0  )
-      !
-      IF( nn_timing == 1 )  CALL timing_stop('ldf_slp_triad')
+      IF( ln_timing )   CALL timing_stop('ldf_slp_triad')
       !
    END SUBROUTINE ldf_slp_triad
@@ -663,5 +646,5 @@
       !!----------------------------------------------------------------------
       !
-      IF( nn_timing == 1 )  CALL timing_start('ldf_slp_mxl')
+      IF( ln_timing )   CALL timing_start('ldf_slp_mxl')
       !
       zeps   =  1.e-20_wp        !==   Local constant initialization   ==!
@@ -746,5 +729,5 @@
       CALL lbc_lnk( wslpiml, 'W', -1. )   ;   CALL lbc_lnk( wslpjml, 'W', -1. )   ! lateral boundary conditions
       !
-      IF( nn_timing == 1 )  CALL timing_stop('ldf_slp_mxl')
+      IF( ln_timing )   CALL timing_stop('ldf_slp_mxl')
       !
    END SUBROUTINE ldf_slp_mxl
@@ -763,5 +746,5 @@
       !!----------------------------------------------------------------------
       !
-      IF( nn_timing == 1 )  CALL timing_start('ldf_slp_init')
+      IF( ln_timing )   CALL timing_start('ldf_slp_init')
       !
       IF(lwp) THEN
@@ -821,5 +804,5 @@
       ENDIF
       !
-      IF( nn_timing == 1 )  CALL timing_stop('ldf_slp_init')
+      IF( ln_timing )   CALL timing_stop('ldf_slp_init')
       !
    END SUBROUTINE ldf_slp_init
Index: /branches/2017/dev_merge_2017/NEMOGCM/NEMO/OPA_SRC/LDF/ldftra.F90
===================================================================
--- /branches/2017/dev_merge_2017/NEMOGCM/NEMO/OPA_SRC/LDF/ldftra.F90	(revision 9018)
+++ /branches/2017/dev_merge_2017/NEMOGCM/NEMO/OPA_SRC/LDF/ldftra.F90	(revision 9019)
@@ -30,5 +30,4 @@
    USE lib_mpp         ! distribued memory computing library
    USE lbclnk          ! ocean lateral boundary conditions (or mpp link)
-   USE wrk_nemo        ! work arrays
    USE timing          ! timing
 
@@ -45,4 +44,5 @@
    !                                   !!* Namelist namtra_ldf : lateral mixing on tracers * 
    !                                    != Operator type =!
+   LOGICAL , PUBLIC ::   ln_traldf_NONE      !: no operator: No explicit diffusion
    LOGICAL , PUBLIC ::   ln_traldf_lap       !: laplacian operator
    LOGICAL , PUBLIC ::   ln_traldf_blp       !: bilaplacian operator
@@ -119,10 +119,10 @@
       INTEGER  ::   ierr, inum, ios   ! local integer
       REAL(wp) ::   zah0              ! local scalar
-      !
-      NAMELIST/namtra_ldf/ ln_traldf_lap, ln_traldf_blp  ,                   &   ! type of operator
-         &                 ln_traldf_lev, ln_traldf_hor  , ln_traldf_triad,  &   ! acting direction of the operator
-         &                 ln_traldf_iso, ln_traldf_msc  ,  rn_slpmax     ,  &   ! option for iso-neutral operator
-         &                 ln_triad_iso , ln_botmix_triad, rn_sw_triad    ,  &   ! option for triad operator
-         &                 rn_aht_0     , rn_bht_0       , nn_aht_ijk_t          ! lateral eddy coefficient
+      !!
+      NAMELIST/namtra_ldf/ ln_traldf_NONE, ln_traldf_lap  , ln_traldf_blp  ,  &   ! type of operator
+         &                 ln_traldf_lev , ln_traldf_hor  , ln_traldf_triad,  &   ! acting direction of the operator
+         &                 ln_traldf_iso , ln_traldf_msc  ,  rn_slpmax     ,  &   ! option for iso-neutral operator
+         &                 ln_triad_iso  , ln_botmix_triad, rn_sw_triad    ,  &   ! option for triad operator
+         &                 rn_aht_0      , rn_bht_0       , nn_aht_ijk_t          ! lateral eddy coefficient
       !!----------------------------------------------------------------------
       !
@@ -144,9 +144,8 @@
          WRITE(numout,*) '~~~~~~~~~~~~ '
          WRITE(numout,*) '   Namelist namtra_ldf : lateral mixing parameters (type, direction, coefficients)'
-         !
          WRITE(numout,*) '      type :'
+         WRITE(numout,*) '         no explicit diffusion                   ln_traldf_NONE  = ', ln_traldf_NONE
          WRITE(numout,*) '         laplacian operator                      ln_traldf_lap   = ', ln_traldf_lap
          WRITE(numout,*) '         bilaplacian operator                    ln_traldf_blp   = ', ln_traldf_blp
-         !
          WRITE(numout,*) '      direction of action :'
          WRITE(numout,*) '         iso-level                               ln_traldf_lev   = ', ln_traldf_lev
@@ -159,5 +158,4 @@
          WRITE(numout,*) '            switching triad or not               rn_sw_triad     = ', rn_sw_triad
          WRITE(numout,*) '            lateral mixing on bottom             ln_botmix_triad = ', ln_botmix_triad
-         !
          WRITE(numout,*) '      coefficients :'
          WRITE(numout,*) '         lateral eddy diffusivity   (lap case)   rn_aht_0        = ', rn_aht_0
@@ -168,5 +166,5 @@
       !                                ! Parameter control
       !
-      IF( .NOT.ln_traldf_lap .AND. .NOT.ln_traldf_blp ) THEN
+      IF( ln_traldf_NONE ) THEN
          IF(lwp) WRITE(numout,*) '   No diffusive operator selected. ahtu and ahtv are not allocated'
          l_ldftra_time = .FALSE.
@@ -490,12 +488,10 @@
       !
       INTEGER  ::   ji, jj, jk    ! dummy loop indices
-      REAL(wp) ::   zfw, ze3w, zn2, z1_f20, zaht, zaht_min, zzaei   ! local scalars
-      REAL(wp), DIMENSION(:,:), POINTER ::   zn, zah, zhw, zross, zaeiw   ! 2D workspace
-      !!----------------------------------------------------------------------
-      !
-      IF( nn_timing == 1 )   CALL timing_start('ldf_eiv')
-      !
-      CALL wrk_alloc( jpi,jpj,   zn, zah, zhw, zross, zaeiw )
-      !      
+      REAL(wp) ::   zfw, ze3w, zn2, z1_f20, zaht, zaht_min, zzaei    ! local scalars
+      REAL(wp), DIMENSION(jpi,jpj) ::   zn, zah, zhw, zross, zaeiw   ! 2D workspace
+      !!----------------------------------------------------------------------
+      !
+      IF( ln_timing )   CALL timing_start('ldf_eiv')
+      !
       zn   (:,:) = 0._wp      ! Local initialization
       zhw  (:,:) = 5._wp
@@ -575,7 +571,5 @@
       END DO
       !  
-      CALL wrk_dealloc( jpi,jpj,   zn, zah, zhw, zross, zaeiw )
-      !
-      IF( nn_timing == 1 )   CALL timing_stop('ldf_eiv')
+      IF( ln_timing )   CALL timing_stop('ldf_eiv')
       !
    END SUBROUTINE ldf_eiv
@@ -610,11 +604,9 @@
       REAL(wp) ::   zuwk, zuwk1, zuwi, zuwi1   ! local scalars
       REAL(wp) ::   zvwk, zvwk1, zvwj, zvwj1   !   -      -
-      REAL(wp), POINTER, DIMENSION(:,:,:) ::   zpsi_uw, zpsi_vw
-      !!----------------------------------------------------------------------
-      !
-      IF( nn_timing == 1 )   CALL timing_start( 'ldf_eiv_trp')
-      !
-      CALL wrk_alloc( jpi,jpj,jpk,   zpsi_uw, zpsi_vw )
-
+      REAL(wp), DIMENSION(jpi,jpj,jpk) ::   zpsi_uw, zpsi_vw
+      !!----------------------------------------------------------------------
+      !
+      IF( ln_timing )   CALL timing_start( 'ldf_eiv_trp')
+      !
       IF( kt == kit000 )  THEN
          IF(lwp) WRITE(numout,*)
@@ -658,7 +650,5 @@
       IF( ln_ldfeiv_dia .AND. cdtype == 'TRA' )   CALL ldf_eiv_dia( zpsi_uw, zpsi_vw )
       !
-      CALL wrk_dealloc( jpi,jpj,jpk,   zpsi_uw, zpsi_vw )
-      !
-      IF( nn_timing == 1 )   CALL timing_stop( 'ldf_eiv_trp')
+      IF( ln_timing )   CALL timing_stop( 'ldf_eiv_trp')
       !
     END SUBROUTINE ldf_eiv_trp
@@ -679,9 +669,11 @@
       INTEGER  ::   ji, jj, jk    ! dummy loop indices
       REAL(wp) ::   zztmp   ! local scalar
-      REAL(wp), DIMENSION(:,:)  , POINTER ::   zw2d   ! 2D workspace
-      REAL(wp), DIMENSION(:,:,:), POINTER ::   zw3d   ! 3D workspace
-      !!----------------------------------------------------------------------
-      !
-      IF( nn_timing == 1 )  CALL timing_start( 'ldf_eiv_dia')
+      REAL(wp), DIMENSION(jpi,jpj)     ::   zw2d   ! 2D workspace
+      REAL(wp), DIMENSION(jpi,jpj,jpk) ::   zw3d   ! 3D workspace
+      !!----------------------------------------------------------------------
+      !
+!!gm I don't like this routine....   Crazy  way of doing things, not optimal at all...
+!!gm     to be redesigned....   
+      IF( ln_timing )   CALL timing_start( 'ldf_eiv_dia')
       !
       !                                                  !==  eiv stream function: output  ==!
@@ -693,5 +685,4 @@
       !
       !                                                  !==  eiv velocities: calculate and output  ==!
-      CALL wrk_alloc( jpi,jpj,jpk,   zw3d )
       !
       zw3d(:,:,jpk) = 0._wp                                    ! bottom value always 0
@@ -718,7 +709,4 @@
       CALL iom_put( "woce_eiv", zw3d )
       !
-      !      
-      !
-      CALL wrk_alloc( jpi,jpj,   zw2d )
       !
       zztmp = 0.5_wp * rau0 * rcp 
@@ -792,8 +780,6 @@
       IF( ln_diaptr ) CALL dia_ptr_hst( jp_sal, 'eiv', 0.5 * zw3d )
       !
-      CALL wrk_dealloc( jpi,jpj,   zw2d )
-      CALL wrk_dealloc( jpi,jpj,jpk,   zw3d )
-      !
-      IF( nn_timing == 1 )  CALL timing_stop( 'ldf_eiv_dia')      
+      !
+      IF( ln_timing )   CALL timing_stop( 'ldf_eiv_dia')      
       !
    END SUBROUTINE ldf_eiv_dia
Index: /branches/2017/dev_merge_2017/NEMOGCM/NEMO/OPA_SRC/OBS/diaobs.F90
===================================================================
--- /branches/2017/dev_merge_2017/NEMOGCM/NEMO/OPA_SRC/OBS/diaobs.F90	(revision 9018)
+++ /branches/2017/dev_merge_2017/NEMOGCM/NEMO/OPA_SRC/OBS/diaobs.F90	(revision 9019)
@@ -14,5 +14,4 @@
    !!   fin_date     : Compute the final date YYYYMMDD.HHMMSS
    !!----------------------------------------------------------------------
-   !! * Modules used
    USE wrk_nemo                 ! Memory Allocation
    USE par_kind                 ! Precision variables
@@ -36,12 +35,11 @@
 
    IMPLICIT NONE
-
-   !! * Routine accessibility
    PRIVATE
-   PUBLIC dia_obs_init, &  ! Initialize and read observations
-      &   dia_obs,      &  ! Compute model equivalent to observations
-      &   dia_obs_wri,  &  ! Write model equivalent to observations
-      &   dia_obs_dealloc, &  ! Deallocate dia_obs data
-      &   calc_date           ! Compute the date of a timestep
+
+   PUBLIC dia_obs_init     ! Initialize and read observations
+   PUBLIC dia_obs          ! Compute model equivalent to observations
+   PUBLIC dia_obs_wri      ! Write model equivalent to observations
+   PUBLIC dia_obs_dealloc  ! Deallocate dia_obs data
+   PUBLIC calc_date        ! Compute the date of a timestep
 
    !! * Module variables
@@ -51,25 +49,14 @@
    INTEGER :: nn_1dint       !: Vertical interpolation method
    INTEGER :: nn_2dint       !: Horizontal interpolation method
-   INTEGER, DIMENSION(imaxavtypes) :: &
-      & nn_profdavtypes      !: Profile data types representing a daily average
+   INTEGER, DIMENSION(imaxavtypes) ::   nn_profdavtypes   !: Profile data types representing a daily average
    INTEGER :: nproftypes     !: Number of profile obs types
    INTEGER :: nsurftypes     !: Number of surface obs types
-   INTEGER, DIMENSION(:), ALLOCATABLE :: &
-      & nvarsprof, &         !: Number of profile variables
-      & nvarssurf            !: Number of surface variables
-   INTEGER, DIMENSION(:), ALLOCATABLE :: &
-      & nextrprof, &         !: Number of profile extra variables
-      & nextrsurf            !: Number of surface extra variables
-   INTEGER, PUBLIC, ALLOCATABLE, DIMENSION(:) :: sstbias_type !SST bias type    
-   TYPE(obs_surf), PUBLIC, POINTER, DIMENSION(:) :: &
-      & surfdata, &          !: Initial surface data
-      & surfdataqc           !: Surface data after quality control
-   TYPE(obs_prof), PUBLIC, POINTER, DIMENSION(:) :: &
-      & profdata, &          !: Initial profile data
-      & profdataqc           !: Profile data after quality control
-
-   CHARACTER(len=6), PUBLIC, DIMENSION(:), ALLOCATABLE :: &
-      & cobstypesprof, &     !: Profile obs types
-      & cobstypessurf        !: Surface obs types
+   INTEGER, DIMENSION(:), ALLOCATABLE ::   nvarsprof, nvarssurf   !: Number of profile & surface variables
+   INTEGER, DIMENSION(:), ALLOCATABLE ::   nextrprof, nextrsurf   !: Number of profile & surface extra variables
+   INTEGER, PUBLIC, ALLOCATABLE, DIMENSION(:) ::   sstbias_type   !: SST bias type    
+   TYPE(obs_surf), PUBLIC, POINTER, DIMENSION(:) ::   surfdata, surfdataqc   !: Initial surface data before & after quality control
+   TYPE(obs_prof), PUBLIC, POINTER, DIMENSION(:) ::   profdata, profdataqc   !: Initial profile data before & after quality control
+
+   CHARACTER(len=6), PUBLIC, DIMENSION(:), ALLOCATABLE ::   cobstypesprof, cobstypessurf   !: Profile & surface obs types
 
    !!----------------------------------------------------------------------
@@ -78,5 +65,4 @@
    !! Software governed by the CeCILL licence (NEMOGCM/NEMO_CeCILL.txt)
    !!----------------------------------------------------------------------
-
 CONTAINS
 
@@ -99,13 +85,6 @@
       !!        !  15-02  (M. Martin) Simplification of namelist and code
       !!----------------------------------------------------------------------
-
-      IMPLICIT NONE
-
-      !! * Local declarations
-      INTEGER, PARAMETER :: &
-         & jpmaxnfiles = 1000    ! Maximum number of files for each obs type
-      INTEGER, DIMENSION(:), ALLOCATABLE :: &
-         & ifilesprof, &         ! Number of profile files
-         & ifilessurf            ! Number of surface files
+      INTEGER, PARAMETER ::   jpmaxnfiles = 1000    ! Maximum number of files for each obs type
+      INTEGER, DIMENSION(:), ALLOCATABLE ::   ifilesprof, ifilessurf   ! Number of profile & surface files
       INTEGER :: ios             ! Local integer output status for namelist read
       INTEGER :: jtype           ! Counter for obs types
@@ -134,5 +113,5 @@
       LOGICAL :: ln_nea          ! Logical switch to remove obs near land
       LOGICAL :: ln_altbias      ! Logical switch for altimeter bias
-      LOGICAL :: ln_sstbias     !: Logical switch for bias corection of SST 
+      LOGICAL :: ln_sstbias      ! Logical switch for bias corection of SST 
       LOGICAL :: ln_ignmis       ! Logical switch for ignoring missing files
       LOGICAL :: ln_s_at_t       ! Logical switch to compute model S at T obs
@@ -291,5 +270,5 @@
             END DO
          ENDIF
-#if defined key_lim2 || defined key_lim3
+#if defined key_lim3
          IF (ln_sic) THEN
             jtype = jtype + 1
@@ -501,4 +480,5 @@
    END SUBROUTINE dia_obs_init
 
+
    SUBROUTINE dia_obs( kstp )
       !!----------------------------------------------------------------------
@@ -525,23 +505,10 @@
       !!        !  15-08  (M. Martin) Combined surface/profile routines.
       !!----------------------------------------------------------------------
-      !! * Modules used
-      USE dom_oce, ONLY : &             ! Ocean space and time domain variables
-         & gdept_n,       &      
-         & gdept_1d      
-      USE phycst, ONLY : &              ! Physical constants
-         & rday                         
-      USE oce, ONLY : &                 ! Ocean dynamics and tracers variables
-         & tsn,  &             
-         & un, vn, &
-         & sshn  
-      USE phycst, ONLY : &         ! Physical constants
-         & rday
+      USE dom_oce, ONLY : gdept_n, gdept_1d   ! Ocean space and time domain variables
+      USE phycst , ONLY : rday                ! Physical constants
+      USE oce    , ONLY : tsn, un, vn, sshn   ! Ocean dynamics and tracers variables
+      USE phycst , ONLY : rday                ! Physical constants
 #if defined  key_lim3
-      USE ice, ONLY : &            ! LIM3 Ice model variables
-         & frld
-#endif
-#if defined key_lim2
-      USE ice_2, ONLY : &          ! LIM2 Ice model variables
-         & frld
+      USE ice    , ONLY : at_i                ! LIM3 Ice model variables
 #endif
       IMPLICIT NONE
@@ -567,6 +534,6 @@
          & zgphi1,    &            ! Model latitudes for prof variable 1
          & zgphi2                  ! Model latitudes for prof variable 2
-#if ! defined key_lim2 && ! defined key_lim3
-      REAL(wp), POINTER, DIMENSION(:,:) :: frld
+#if ! defined key_lim3
+      REAL(wp), POINTER, DIMENSION(:,:) :: at_i
 #endif
       LOGICAL :: llnightav        ! Logical for calculating night-time average
@@ -582,7 +549,8 @@
       CALL wrk_alloc( jpi, jpj, zgphi1 )
       CALL wrk_alloc( jpi, jpj, zgphi2 )
-#if ! defined key_lim2 && ! defined key_lim3
-      CALL wrk_alloc(jpi,jpj,frld) 
+#if ! defined key_lim3
+      CALL wrk_alloc(jpi,jpj,at_i) 
 #endif
+      !-----------------------------------------------------------------------
 
       IF(lwp) THEN
@@ -595,8 +563,8 @@
 
       !-----------------------------------------------------------------------
-      ! No LIM => frld == 0.0_wp
-      !-----------------------------------------------------------------------
-#if ! defined key_lim2 && ! defined key_lim3
-      frld(:,:) = 0.0_wp
+      ! No LIM => at_i == 0.0_wp
+      !-----------------------------------------------------------------------
+#if ! defined key_lim3
+      at_i(:,:) = 0.0_wp
 #endif
       !-----------------------------------------------------------------------
@@ -665,5 +633,5 @@
                zsurfvar(:,:) = sshn(:,:)
                llnightav = .FALSE.
-#if defined key_lim2 || defined key_lim3
+#if defined key_lim3
             CASE('sic')
                IF ( kstp == 0 ) THEN
@@ -678,5 +646,5 @@
                   CYCLE
                ELSE
-                  zsurfvar(:,:) = 1._wp - frld(:,:)
+                  zsurfvar(:,:) = at_i(:,:)
                ENDIF
 
@@ -702,6 +670,6 @@
       CALL wrk_dealloc( jpi, jpj, zgphi1 )
       CALL wrk_dealloc( jpi, jpj, zgphi2 )
-#if ! defined key_lim2 && ! defined key_lim3
-      CALL wrk_dealloc(jpi,jpj,frld)
+#if ! defined key_lim3
+      CALL wrk_dealloc(jpi,jpj,at_i)
 #endif
 
Index: /branches/2017/dev_merge_2017/NEMOGCM/NEMO/OPA_SRC/SBC/fldread.F90
===================================================================
--- /branches/2017/dev_merge_2017/NEMOGCM/NEMO/OPA_SRC/SBC/fldread.F90	(revision 9018)
+++ /branches/2017/dev_merge_2017/NEMOGCM/NEMO/OPA_SRC/SBC/fldread.F90	(revision 9019)
@@ -116,5 +116,5 @@
    END TYPE WGT
 
-   INTEGER,     PARAMETER             ::   tot_wgts = 10
+   INTEGER,     PARAMETER             ::   tot_wgts = 20
    TYPE( WGT ), DIMENSION(tot_wgts)   ::   ref_wgts     ! array of wgts
    INTEGER                            ::   nxt_wgt = 1  ! point to next available space in ref_wgts array
Index: /branches/2017/dev_merge_2017/NEMOGCM/NEMO/OPA_SRC/SBC/ocealb.F90
===================================================================
--- /branches/2017/dev_merge_2017/NEMOGCM/NEMO/OPA_SRC/SBC/ocealb.F90	(revision 9019)
+++ /branches/2017/dev_merge_2017/NEMOGCM/NEMO/OPA_SRC/SBC/ocealb.F90	(revision 9019)
@@ -0,0 +1,49 @@
+MODULE ocealb
+   !!======================================================================
+   !!                       ***  MODULE  ocealb  ***
+   !! Ocean forcing:  bulk thermohaline forcing of the ocean
+   !!=====================================================================
+   !! History :
+   !!   NEMO     4.0  ! 2017-07  (C. Rousset) Split ocean and ice albedos
+   !!----------------------------------------------------------------------
+   !!   oce_alb    : albedo for ocean (clear and overcast skies)
+   !!----------------------------------------------------------------------
+   USE phycst         ! physical constants
+   USE in_out_manager ! I/O manager
+   USE lib_mpp        ! MPP library
+   USE wrk_nemo       ! work arrays
+   USE lib_fortran    ! Fortran utilities (allows no signed zero when 'key_nosignedzero' defined)  
+
+   IMPLICIT NONE
+   PRIVATE
+
+   PUBLIC   oce_alb   ! routine called by sbccpl
+  
+   !!----------------------------------------------------------------------
+   !! NEMO/OPA 4.0 , NEMO Consortium (2010)
+   !! $Id: ocealb.F90 8268 2017-07-03 15:01:04Z clem $
+   !! Software governed by the CeCILL licence     (NEMOGCM/NEMO_CeCILL.txt)
+   !!----------------------------------------------------------------------
+CONTAINS
+
+   SUBROUTINE oce_alb( palb_os , palb_cs )
+      !!----------------------------------------------------------------------
+      !!               ***  ROUTINE oce_alb  ***
+      !! 
+      !! ** Purpose :   Computation of the albedo of the ocean
+      !!----------------------------------------------------------------------
+      REAL(wp), DIMENSION(:,:), INTENT(out) ::   palb_os   !  albedo of ocean under overcast sky
+      REAL(wp), DIMENSION(:,:), INTENT(out) ::   palb_cs   !  albedo of ocean under clear sky
+      !!
+      REAL(wp) ::   zcoef 
+      REAL(wp) ::   rmue = 0.40    !  cosine of local solar altitude
+      !!----------------------------------------------------------------------
+      !
+      zcoef = 0.05 / ( 1.1 * rmue**1.4 + 0.15 )   ! Parameterization of Briegled and Ramanathan, 1982
+      palb_cs(:,:) = zcoef 
+      palb_os(:,:) = 0.06                         ! Parameterization of Kondratyev, 1969 and Payne, 1972
+      !
+   END SUBROUTINE oce_alb
+
+   !!======================================================================
+END MODULE ocealb
